<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
	define("AREA", "user");

	include_once "lib/init.inc.php";


	$hardware_node = get_node($_SESSION['user']);
	$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);

	if(@$_GET['month'] != "")
	{
		$month = $_GET['month'];
	}
	else
	{
		$month = date("m");
	}

	$output = vcp_exec($socket, "TRAFFIC ".$_SESSION['user']." ".$month);

	if($output != "" && $output != "N/A")
	{

		$output = explode(" - ", $output);
		$output = explode(" ", $output[0]);
	
		$traffic = array();
		$i = 0;
	
	
		while(@$output[($i*6)+1] != "")
		{
			if(@$_GET['ip'] == "" || @$_GET['ip'] == "All" || @$_GET['ip'] == $output[($i*6)])
			{
				if(!isset( $traffic[ $output[($i*6)+1] ]))
					$traffic[$output[($i*6)+1]] = 0;
	
				$traffic[ ($output[($i*6)+1]) ] += ($output[($i*6)+5]/1000/1000);
	
			}

			$i++;
			
		}
		
	
		$peak = 0; $i = 0;
	
		foreach($traffic as $value)
		{
			if($peak == 0)
			{
				$peak = $value;
			}
			else
			{
				if($value > $peak)
					$peak = $value;
			}
		}
	
	}
	
	header ("Content-type: image/png");
	
	$days = date("t", mktime (0, 0, 0, $month))+1;
	
	$height = 150;
	$width = 550;
	
	$xlinex1 = $width*0.10;
	$xlinex2 = $width*0.90;
	$xliney = $height*0.90;
		
	$ylinex = $width*0.10;
	$yliney1 = $height*0.05;
	$yliney2 = $height*0.90;
	
	$line_width = ($height+$width)/2*0.02;
	$bar_width = (($xlinex2 - $xlinex1)/$days)*0.85;
	
	$font_offset = 0.05;
	$font_size = 1;
	
	$image = ImageCreate ($width, $height)
		or die ("Couldn't create GD-Stream");
	
	$background_color = ImageColorAllocate ($image, 255, 255, 255);
	$text_color = ImageColorAllocate ($image, 0, 0, 0);
	$bar_color = ImageColorAllocate ($image, 0, 0, 139);
	
	imageline ($image, $xlinex1, $xliney, $xlinex2, $xliney, $text_color);
	imageline ($image, $ylinex, $yliney1, $ylinex, $yliney2, $text_color);
	
	$i = 0;
	$segments = $days;
	while($i != $segments)
	{
		//X
		imageline ($image, (($xlinex2-$xlinex1)/$segments)*$i+$xlinex1, $xliney-($line_width/2), (($xlinex2-$xlinex1)/$segments)*$i+$xlinex1, $xliney+($line_width/2), $text_color);
		ImageString ($image, $font_size, (($xlinex2-$xlinex1)/$segments)*$i+$xlinex1, $xliney+($xliney*$font_offset), $i, $text_color);

		$i++;
	}


	if(!isset($peak) || $peak==0)
		$peak = 10000;

	$i = 0;
	$segments = $peak;
	$step = $segments/($height/18);
	while($i <= $segments)
	{
		//Y
	
		imageline ($image, $ylinex-($line_width/2), (($yliney2-$yliney1)/$segments)*($segments-$i)+$yliney1, $ylinex+($line_width/2), (($yliney2-$yliney1)/$segments)*($segments-$i)+$yliney1, $text_color);
		ImageString ($image, $font_size, 5, (($yliney2-$yliney1)/$segments)*($segments-$i)+$yliney1, number_format($i/1000, 1)." GB", $text_color);
	
		$i += $step;
	}

	if(isset($traffic) && is_array($traffic))
	{
		foreach($traffic as $key => $value)
		{
			imagefilledrectangle ($image, ((($xlinex2-$xlinex1)/$days)*$key+$xlinex1)-($bar_width/2), (($yliney2-$yliney1)/$peak)*($segments-$value)+$yliney1,  (($xlinex2-$xlinex1)/$days)*$key+$xlinex1+($bar_width/2), $xliney, $bar_color);
		}
	}

	ImagePNG ($image);


?>
