<?
/** OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


function vcp_connect($ip, $pw, $tls = 'n')
{
	$timeout = 1;

	$vcp_socket['socket'] = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
	
		
	if($ip != "")
	{

		socket_set_nonblock($vcp_socket['socket'])
		     or die("Unable to set nonblock on socket\n");

  		$time = time();
  
		while (!@socket_connect($vcp_socket['socket'], $ip, 6000))
	  	{
     			$err = socket_last_error($vcp_socket['socket']);

     			if ($err == 115 || $err == 114)
     			{
       			      if ((time() - $time) >= $timeout)
       			      {
        				socket_close($vcp_socket['socket']);
        				return FALSE;
       			      }
       		
				usleep(100);
                               continue;
     			}

		     return FALSE;
 		  }

   		socket_set_block($vcp_socket['socket']);

                if($tls == 'y' && function_exists('gnutls_session_new'))
                {

	              socket_write($vcp_socket['socket'], "TLS\n");
		      $output = socket_read ($vcp_socket['socket'], 10);
                      $output = trim($output);

		      if($output == "OK")
		      {

                                $session = gnutls_session_new(GNUTLS_CLIENT);
                                $cred = gnutls_credentials_new(CRED_ANON_CLIENT);


                                gnutls_set_default_priority($session);


                                gnutls_kx_set_priority($session, GNUTLS_KX_ANON_DH);

                                gnutls_session_set_credentials($session, $cred);

        
                                gnutls_session_set_socket($session, $vcp_socket['socket']);

                                gnutls_handshake($session);


                                gnutls_record_send($session, "PASSWORD $pw\n");


	                        $output = gnutls_record_recv($session, 10);
				
				
                                $output = trim($output);

		                if($output != "OK")
		                {
			          @socket_close($vcp_socket['socket']);
			          $vcp_socket = FALSE;
		                }
                                else
                                {
        			     $vcp_socket['session'] = $session;
                                }
                      }  

                }
                else
                {

                      socket_write($vcp_socket['socket'], "PLAINTEXT\n");
		   
		      $output = socket_read ($vcp_socket['socket'], 5);
		   
	              socket_write($vcp_socket['socket'], "PASSWORD $pw\n");
		      $output = socket_read ($vcp_socket['socket'], 5);

		      if($output != "OK\n")
		      {
			     @socket_close($vcp_socket['socket']);
			     $vcp_socket = FALSE;
		      }
                }
	}
	else
	{
		$vcp_socket = FALSE;
	}
	
	
	return $vcp_socket;

}

function vcp_exec($vcp_socket, $args = "")
{
	if($vcp_socket == FALSE)
		return FALSE;

	$statsocks = array($vcp_socket['socket']);


	if(socket_select($read = NULL, $statsocks, $except = NULL, 0, 10000) > 0)
	{
		if($args[strlen($args)-1] != "\n")
			$args = $args."\n";

                if(isset($vcp_socket['session']))
                        gnutls_record_send($vcp_socket['session'], $args);
                else
        		socket_write($vcp_socket['socket'], $args);

	}
	else
	{
		return FALSE;
	}
	

	$statsocks = array($vcp_socket['socket']);

	$output = "";

	if(($ret = socket_select($statsocks, $write = NULL, $except = NULL, 500, 60000)) != -1)
	{
		if($ret > 0)
		{
                        if(isset($vcp_socket['session']))
                                $output = gnutls_record_recv($vcp_socket['session'], 5000);
                        else
        			$output = socket_read($vcp_socket['socket'], 5000, PHP_BINARY_READ);

			$output = trim($output);
		}
	}
	else
	{
		$output = "Timeout";
	}



	
   
	return $output;

}

function vcp_close($vcp_socket)
{
        if(isset($vcp_socket['session']))
                
        gnutls_bye($vcp_socket['session'], GNUTLS_SHUT_RDWR);

        socket_close($vcp_socket['socket']);

}

function get_node($user)
{

	$mysql_id = mysql_query("SELECT node FROM users WHERE name = '$user'") OR die("Datenbank Fehler");
	$mysql_result = mysql_fetch_assoc($mysql_id);
	
	$mysql_id = mysql_query("SELECT ip,password,tls_support FROM nodes WHERE id = '$mysql_result[node]'") OR die("Database Error");
	$mysql_result = mysql_fetch_assoc($mysql_id);

	return $mysql_result;
}

function check_user($user, $pw)
{
        $url_scheme = (strtolower(@$_SERVER['HTTPS'])=='on') ? 'https://' : 'http://';
        if($user != "")
        {
                
		    $user = mysql_escape_safe($user);

                $id = mysql_query("SELECT name, password FROM users WHERE name = '".$user."'") OR die("Database Error");
                $admin = mysql_query("SELECT admin_password FROM options");
                $result = mysql_fetch_assoc($id);
                $admin_result = mysql_fetch_assoc($admin);

                if(($result['password'] == md5($pw) && ($result['name'] == $user)) || (($result['name'] == $user) && (mysql_num_rows($id) == 1) && $admin_result['admin_password'] == md5($pw)))
                {
                        return TRUE;
                }
                else
                {
                        return FALSE;
                }

        }
        else
        {
                header("Location: $url_scheme".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/login.php");
        }

}

function check_user_redirect($user, $pw)
{
        $url_scheme = (strtolower(@$_SERVER['HTTPS'])=='on') ? 'https://' : 'http://';
        if($user != "")
        {
                $user = mysql_escape_safe($user);
        
                $id = mysql_query("SELECT name, password FROM users WHERE name = '".$user."'") OR die("Database Error");
                $admin = mysql_query("SELECT admin_password FROM options");
                $result = mysql_fetch_assoc($id);
                $admin_result = mysql_fetch_assoc($admin);

                if(($result['password'] == md5($pw) && ($result['name'] == $user)) || (($result['name'] == $user) && (mysql_num_rows($id) == 1) && $admin_result['admin_password'] == md5($pw)))
                {
			#echo "valid user";
                        return TRUE;
                }
                else
                {
			#echo "Resname ".$result['name']." Name: ".$user." Pass: ".$pw." MD5: ".md5($pw)." Adminpass: ".$admin_result['admin_password']." ";
                        header("Location: $url_scheme".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/login.php?wrong");
                }

        }
        else
        {
                header("Location: $url_scheme".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/login.php");
        }
}

function check_admin($user, $password)
{

        $url_scheme = (strtolower(@$_SERVER['HTTPS'])=='on') ? 'https://' : 'http://';
	$dir = str_replace("/admin", "", dirname($_SERVER['PHP_SELF']));
        if($user != "")
        {

                $mysql_id = mysql_query("SELECT admin_password FROM options");
                $mysql_result = mysql_fetch_assoc($mysql_id);

                if($mysql_result['admin_password'] == md5($password) && $user == "Admin")
                {

                        return TRUE;
                }
                else
                {
                        header("Location: $url_scheme".$_SERVER['HTTP_HOST'].$dir."/login.php?failed");
                        return FALSE;
                }

        }
        else
        {
                header("Location: $url_scheme".$_SERVER['HTTP_HOST'].$dir."/login.php");
                return FALSE;
        }
}



function get_node_by_id($id)
{
	
	$mysql_id = mysql_query("SELECT ip,password, tls_support FROM nodes WHERE id='".mysql_escape_safe($id)."'") OR die("Datenbank Fehler");
	$mysql_result = mysql_fetch_assoc($mysql_id);

	return $mysql_result;
}



function create_password($length=8)
{
   mt_srand((double)microtime()*1000000);
   $newstring="";

   if($length>0)
   {

      while(strlen($newstring)<$length)
	{
           switch(mt_rand(1,3))
		{
               case 1: $newstring.=chr(mt_rand(48,57)); break;  // 0-9
               case 2: $newstring.=chr(mt_rand(65,90)); break;  // A-Z
               case 3: $newstring.=chr(mt_rand(97,122)); break; // a-z
           }
       }
   }
   
      
   $pw[0] = $newstring;
   $pw[1] = crypt($newstring);
   
   return $pw;
}



function error_page($message)
{	

	$page_content = tpl_load("message");

	$page_content = tpl_set($page_content, "[TYPE]", "ERROR");
	$page_content = tpl_set($page_content, "[MESSAGE]", $message);

	
	die($page_content);
}


/// function to check one quarter of the ip
function check_sub_ip($ip)
{
	if(0 <= $ip && $ip <= 255)
		return true;
	else
		return false;
}

/// function to check used IPs and set to used when not marked as used or insert if ip doesn't exist
function check_used_ip($ip,$node,$vservername)
{
	$ip = mysql_escape_safe($ip);

	$cui_mysql_id = mysql_query("SELECT ip,used,vserver,node FROM networks WHERE ip = '".$ip."'");
	$cui_mysql_result = mysql_fetch_assoc($cui_mysql_id);
	if($ip != "127.0.0.1" && $ip !="N/A")
	{
		if(mysql_num_rows($cui_mysql_id) > 0)
		{
			if($cui_mysql_result['used'] != 1 || $cui_mysql_result['vserver'] != $vservername || $cui_mysql_result['node'] != $node)
			{
				mysql_query("UPDATE networks SET used = '1', vserver = '$vservername', node = '$node' WHERE ip = '$ip'");
			}
		}
		else
		{
			mysql_query("INSERT INTO networks SET ip = '$ip', used = '1', vserver = '$vservername', node = '$node'");
		}
	}
	return 1;
}

function compare_ips($ip1, $ip2)
{
	if(is_array($ip1))
		$ip1 = explode(".", $ip1['ip']);
	else	
		$ip1 = explode(".", $ip1);
		
	if(is_array($ip2))	
		$ip2 = explode(".", $ip2['ip']);
	else	
		$ip2 = explode(".", $ip2);


	foreach($ip1 as $key => $value)
	{
		if($value > $ip2[$key])
			return 1;	
		if($value < $ip2[$key])
			return -1;
	}


	return 0;
}

/// function to create a dropdown box with available IP Adresses
function create_availableip_dropdown($ips = "")
{
	$mysql_id = mysql_query("SELECT * FROM networks WHERE used = 0 ORDER BY `ip` ASC ");

	while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
	{
		if(strstr($ips,$mysql_result['ip']) == false)
			$free_ips[] = $mysql_result['ip'];
	}
	
	
	usort($free_ips,  "compare_ips");

	$dropdown = "<select name=ip>";	
	foreach($free_ips as $ip)
	{
		$dropdown .= "\t<option value=\"".$ip."\">".$ip."</option>\n";
	}
	$dropdown .= "</select>";
					
	return $dropdown;
}

///function to create a dropdownbox for the nodes
function create_node_dropdown($node = 0)
{
	$nodes = "<select name=nodes>";
	
	$mysql_id = mysql_query("SELECT id,name FROM nodes");

	while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
	{
		if(isset($node) && $node == $mysql_result['id'])
		{
			$nodes .= "<option selected value=\"$mysql_result[id]\">$mysql_result[name]</option>";
		}
		else
		{
			$nodes .= "<option value=\"$mysql_result[id]\">$mysql_result[name]</option>";
		}
	}
	$nodes .= "</select>";
	return $nodes;
}

///function to create a dropdownbox for the admins
function create_admin_dropdown($admin = 0)
{
	$admins = "<select name=admins>";

	$mysql_id = mysql_query("SELECT id,name FROM admins");

	while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
	{
		if(isset($admin) && $admin == $mysql_result['id'])
		{
			$admins .= "<option selected value=\"$mysql_result[id]\">$mysql_result[name]</option>";
		}
		else
		{
			$admins .= "<option value=\"$mysql_result[id]\">$mysql_result[name]</option>";
		}
	}
	$admins .= "</select>";
	return $admins;
}

///function to create a dropdownbox of all vServers
function create_vserver_dropdown()
{
	$vservers = "<select name=vservers>";
	/// GRABBING VSLIST to get all vserver names
	$mysql_id = mysql_query("SELECT id, name, ip, password FROM nodes");
	while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
		{
		if($mysql_result['ip'] != "")
		{
			/// insert NODE ip as used
			check_used_ip($mysql_result['ip'],$mysql_result['id'],$mysql_result['name']);

			$socket = vcp_connect($mysql_result['ip'], $mysql_result['password']);
			$vslist = vcp_exec($socket, "LIST");
			rtrim($vslist);

			$vslist = explode(" ", $vslist);
	
			foreach($vslist as $vsname)
			{
				$vsname = mysql_escape_safe($vsname);

				$mysql_subid = mysql_query("SELECT * FROM users WHERE name = '".$vsname."'");
				if(mysql_num_rows($mysql_subid) < 1)
					$vservers .= "<option value=\"$vsname:".$mysql_result['id']."\">$vsname</option>";
			}
		}
	}
	$vservers .= "</select>";
	return $vservers;
}



function mysql_escape_safe($string)
{
	if(get_magic_quotes_gpc() == -1)
	{
		if(version_compare(phpversion(),"4.3.0") == -1) 
		{
			$string = mysql_escape_string($string);
		} 
		else 
		{
			$string =  mysql_real_escape_string($string);
		}
	}

	return $string;
}

function eth_split($input)
{


	$array = explode(" ",$input);

	for($i = 0;$i < count($array)/5;$i++)
	{
		for($j = $i*5;$j < $i*5+5; $j++)
		{
			$result[$i][] = $array[$j];
		}
	}
	
	return $result;
}

?>
