CREATE TABLE `nodes` (
  `id` int(11) NOT NULL auto_increment,
  `name` tinytext NOT NULL,
  `ip` varchar(16) NOT NULL default '',
  `password` tinytext NOT NULL,
  `tls_support` char(1) NOT NULL default 'n',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;


CREATE TABLE `options` (
  `admin_password` tinytext NOT NULL,
  `version` varchar(10) NOT NULL default ''
) ENGINE=MyISAM;

INSERT INTO `options` (`admin_password`, `version`) VALUES ('098f6bcd4621d373cade4e832627b4f6', '0.2 alpha');


CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `name` tinytext NOT NULL,
  `password` tinytext NOT NULL,
  `firstname` tinytext NOT NULL,
  `lastname` tinytext NOT NULL,
  `street` tinytext NOT NULL,
  `city` tinytext NOT NULL,
  `postcode` tinytext NOT NULL,
  `tel` tinytext NOT NULL,
  `email` tinytext NOT NULL,
  `node` int(11) NOT NULL default '0',
  `adminid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

CREATE TABLE `navigation` (
  `id` int(11) NOT NULL auto_increment,
  `name` tinytext NOT NULL,
  `section` tinytext NOT NULL,
  `link` varchar(255) NOT NULL default '',
  `image` varchar(255) NOT NULL default '',
  `order` int(4) NOT NULL default '0',
  `area` tinytext NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

-- 
-- Daten fr Tabelle `navigation`
-- 

INSERT INTO `navigation` (`id`, `name`, `section`, `link`, `image`, `order`, `area`) VALUES 
(1, 'Info', '', '', '', 10, 'user'),
(2, 'Traffic', 'Info', 'traffic.php', 'images/traffic.gif', 10, 'user'),
(3, 'Status', 'Info', 'index.php', 'images/status.gif', 0, 'user'),
(4, 'Control', '', '', '', 20, 'user'),
(5, 'Start/Stop', 'Control', 'startstop.php', 'images/vs.gif', 10, 'user'),
(6, 'Reinstall', 'Control', 'reinstall.php', 'images/reinstall.gif', 20, 'user'),
(7, 'Options', '', '', '', 30, 'user'),
(8, 'Personal Data', 'Options', 'personal.php', 'images/personal.gif', 10, 'user'),
(9, 'Password', 'Options', 'password.php', 'images/password.gif', 20, 'user'),
(10, 'Logout', 'Options', 'login.php?user', 'images/del.gif', 100, 'user'),
(11, 'Nodes', '', '', '', 10, 'admin'),
(12, 'Overview', 'Nodes', 'index.php', '../images/node.gif', 10, 'admin'),
(13, 'Add Node', 'Nodes', 'add_node.php', '../images/addnode.gif', 20, 'admin'),
(14, 'Network', '', '', '', 20, 'admin'),
(15, 'Overview', 'Network', 'manage_networks.php', './../images/network.png', 10, 'admin'),
(16, 'Add Network', 'Network', 'manage_networks.php?page=addiprange', '../images/reinstall.gif', 20, 'admin'),
(17, 'vServer', '', '', '', 20, 'admin'),
(18, 'Overview', 'vServer', 'vserver.php', '../images/vs.gif', 10, 'admin'),
(19, 'Add vServer', 'vServer', 'create_vserver.php', '../images/reinstall.gif', 20, 'admin'),
(20, 'Users', '', '', '', 40, 'admin'),
(21, 'Overview', 'Users', 'manage_users.php', './../images/users.png', 10, 'admin'),
(22, 'Add User', 'Users', 'manage_users.php?page=add', './../images/adduser.png', 20, 'admin'),
(23, 'Options', '', '', '', 50, 'admin'),
(24, 'Password', 'Options', 'password.php', '../images/password.gif', 10, 'admin'),
(25, 'Logout', 'Options', '../login.php?admin', '../images/del.gif', 100, 'admin');

CREATE TABLE `networks` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`ip` VARCHAR( 20 ) NOT NULL ,
`used` TINYINT( 1 ) NOT NULL DEFAULT '0',
`vserver` VARCHAR( 255 ) NOT NULL ,
`node` INT( 11 ) NOT NULL
) ENGINE = MYISAM ;

CREATE TABLE `admins` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 255 ) NOT NULL ,
`traffic_total` INT( 20 ) NOT NULL ,
`space_total` INT( 20 ) NOT NULL ,
`vserver_total` INT( 10 ) NOT NULL ,
`node` INT( 11 ) NOT NULL ,
`can_see_nodes` INT( 1 ) NULL,
`can_add_node` INT( 1 ) NULL
) ENGINE = MYISAM ;
